"use strict";
exports.__esModule = true;
exports.useConnection = void 0;
var tslib_1 = require("tslib");
/* eslint-disable @typescript-eslint/no-empty-function */
var react_1 = tslib_1.__importStar(require("react"));
var react_use_websocket_1 = tslib_1.__importStar(require("react-use-websocket"));
var ConnectionContext = (0, react_1.createContext)({
    connectionStatus: react_use_websocket_1.ReadyState.UNINSTANTIATED,
    sendMessage: function () { },
    lastMessage: null,
    changeConnectionUrl: function () { }
});
var ConnectionProvider = function (_a) {
    var children = _a.children, socketUrl = _a.socketUrl, options = _a.options;
    var _b = (0, react_1.useState)(""), connectionUrl = _b[0], setConnectionUrl = _b[1];
    var _c = (0, react_use_websocket_1["default"])(connectionUrl, options), readyState = _c.readyState, sendJsonMessage = _c.sendJsonMessage, lastJsonMessage = _c.lastJsonMessage;
    (0, react_1.useEffect)(function () {
        setConnectionUrl(socketUrl);
    }, [socketUrl]);
    var changeConnectionUrl = (0, react_1.useCallback)(function (url) {
        setConnectionUrl(url);
    }, []);
    var sendMessage = (0, react_1.useCallback)(function (message) {
        sendJsonMessage(message);
    }, [sendJsonMessage]);
    var contextValue = (0, react_1.useMemo)(function () {
        return {
            connectionStatus: readyState,
            changeConnectionUrl: changeConnectionUrl,
            sendMessage: sendMessage,
            lastMessage: lastJsonMessage
        };
    }, [changeConnectionUrl, lastJsonMessage, readyState, sendMessage]);
    var Provider = ConnectionContext.Provider;
    return react_1["default"].createElement(Provider, { value: contextValue }, children);
};
var useConnection = function () { return (0, react_1.useContext)(ConnectionContext); };
exports.useConnection = useConnection;
exports["default"] = ConnectionProvider;
//# sourceMappingURL=ConnectionProvider.js.map